// Session.h : Declaration of the CConversionProviderSession
#ifndef __CConversionProviderSession_H_
#define __CConversionProviderSession_H_
#include "resource.h"       // main symbols
#include "ConversionProviderRS.h"
class CConversionProviderSessionTRSchemaRowset;
class CConversionProviderSessionColSchemaRowset;
class CConversionProviderSessionPTSchemaRowset;
/////////////////////////////////////////////////////////////////////////////
// CConversionProviderSession
class ATL_NO_VTABLE CConversionProviderSession : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IGetDataSourceImpl<CConversionProviderSession>,
	public IOpenRowsetImpl<CConversionProviderSession>,
	public ISessionPropertiesImpl<CConversionProviderSession>,
	public IObjectWithSiteSessionImpl<CConversionProviderSession>,
	//public IDBSchemaRowsetImpl<CConversionProviderSession>,
	public IDBCreateCommandImpl<CConversionProviderSession, CConversionProviderCommand>
{
public:
	CConversionProviderSession()
	{
	}
	HRESULT FinalConstruct()
	{
		return FInit();
	}
	STDMETHOD(OpenRowset)(IUnknown *pUnk, DBID *pTID, DBID *pInID, REFIID riid,
					   ULONG cSets, DBPROPSET rgSets[], IUnknown **ppRowset)
	{
		CConversionProviderRowset* pRowset;
		return CreateRowset(pUnk, pTID, pInID, riid, cSets, rgSets, ppRowset, pRowset);
	}
BEGIN_PROPSET_MAP(CConversionProviderSession)
	BEGIN_PROPERTY_SET(DBPROPSET_SESSION)
		PROPERTY_INFO_ENTRY(SESS_AUTOCOMMITISOLEVELS)
	END_PROPERTY_SET(DBPROPSET_SESSION)
END_PROPSET_MAP()
BEGIN_COM_MAP(CConversionProviderSession)
	COM_INTERFACE_ENTRY(IGetDataSource)
	COM_INTERFACE_ENTRY(IOpenRowset)
	COM_INTERFACE_ENTRY(ISessionProperties)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IDBCreateCommand)
	//COM_INTERFACE_ENTRY(IDBSchemaRowset)
END_COM_MAP()
//BEGIN_SCHEMA_MAP(CConversionProviderSession)
//	SCHEMA_ENTRY(DBSCHEMA_TABLES, CConversionProviderSessionTRSchemaRowset)
//	SCHEMA_ENTRY(DBSCHEMA_COLUMNS, CConversionProviderSessionColSchemaRowset)
//	SCHEMA_ENTRY(DBSCHEMA_PROVIDER_TYPES, CConversionProviderSessionPTSchemaRowset)
//END_SCHEMA_MAP()
};
   /*
class CConversionProviderSessionTRSchemaRowset : 
	public CRowsetImpl< CConversionProviderSessionTRSchemaRowset, CTABLESRow, CConversionProviderSession>
{
public:
	HRESULT Execute(LONG* pcRowsAffected, ULONG, const VARIANT*)
	{
		USES_CONVERSION;
		CConversionProviderWindowsFile wf;
		CTABLESRow trData;
		lstrcpyW(trData.m_szType, OLESTR("TABLE"));
		lstrcpyW(trData.m_szDesc, OLESTR("The Directory Table"));
		HANDLE hFile = INVALID_HANDLE_VALUE;
		TCHAR szDir[MAX_PATH + 1];
		DWORD cbCurDir = GetCurrentDirectory(MAX_PATH, szDir);
		lstrcat(szDir, _T("\\*.*"));
		hFile = FindFirstFile(szDir, &wf);
		if (hFile == INVALID_HANDLE_VALUE)
			return E_FAIL; // User doesn't have a c:\ drive
		FindClose(hFile);
		lstrcpynW(trData.m_szTable, T2OLE(szDir), SIZEOF_MEMBER(CTABLESRow, m_szTable));
		if (!m_rgRowData.Add(trData))
			return E_OUTOFMEMORY;
		*pcRowsAffected = 1;
		return S_OK;
	}
	DBSTATUS GetDBStatus(CSimpleRow*, ATLCOLUMNINFO* pInfo)
	{
		if (pInfo->iOrdinal == 1 || pInfo->iOrdinal == 2)
			return DBSTATUS_S_ISNULL;
		return DBSTATUS_S_OK;
	}
};
class CConversionProviderSessionColSchemaRowset : 
	public CRowsetImpl< CConversionProviderSessionColSchemaRowset, CCOLUMNSRow, CConversionProviderSession>
{
public:
	HRESULT Execute(LONG* pcRowsAffected, ULONG, const VARIANT*)
	{
		USES_CONVERSION;
		CConversionProviderWindowsFile wf;
		HANDLE hFile = INVALID_HANDLE_VALUE;
		TCHAR szDir[MAX_PATH + 1];
		DWORD cbCurDir = GetCurrentDirectory(MAX_PATH, szDir);
		lstrcat(szDir, _T("\\*.*"));
		hFile = FindFirstFile(szDir, &wf);
		if (hFile == INVALID_HANDLE_VALUE)
			return E_FAIL; // User doesn't have a c:\ drive
		FindClose(hFile);// szDir has got the tablename
		DBID dbid;
		memset(&dbid, 0, sizeof(DBID));
		dbid.uName.pwszName = T2OLE(szDir);
		dbid.eKind = DBKIND_NAME;
		return InitFromRowset < _RowsetArrayType > (m_rgRowData, &dbid, NULL, m_spUnkSite, pcRowsAffected);
	}
	DBSTATUS GetDBStatus(CSimpleRow*, ATLCOLUMNINFO* pInfo)
	{
		switch(pInfo->iOrdinal)
		{
		case 1:
		case 2:
		case 19:
		case 20:
		case 22:
		case 23:
		case 25:
		case 26:
			return DBSTATUS_S_ISNULL;
		default:
			return DBSTATUS_S_OK;
		}
	}
};
class CConversionProviderSessionPTSchemaRowset : 
	public CRowsetImpl< CConversionProviderSessionPTSchemaRowset, CPROVIDER_TYPERow, CConversionProviderSession>
{
public:
	HRESULT Execute(LONG* pcRowsAffected, ULONG, const VARIANT*)
	{
		return S_OK;
	}
};
   */
#endif //__CConversionProviderSession_H_
